leetcode542 01矩阵

一、问题描述

二、解题思路

可以使用多源bfs的方法来解决这个问题,由于本题需要聚焦到每一个为1的位置。所以,需要定义一个dis向量来记录1到最近的0的距离,所有元素值初始化为-1。解题思路如下:

(1)首先,遍历mat,将matij==0的(i,j)入队,并将disij由-1修改为0,表示其到最近的0的距离为0;

(2)接下来进行bfs。将队头元素弹出,遍历其四周,如果坐标不越界且disnext_xnext_y==-1,即该位置为1且未被辐射到,就将其dis值修改为discur_xcur_y+1。

辐射完后,返回dis,即为所求。

三、代码实现

cpp 复制代码
class Solution {
    int N,M;
    vector<vector<int>> dis;

    int dx[4]={0,1,0,-1};
    int dy[4]={-1,0,1,0};
public:
    vector<vector<int>> updateMatrix(vector<vector<int>>& mat) {
        //多源bfs(以0为中心进行扩散)
        //全局变量初始化
        N=mat.size();M=mat[0].size();
        dis.resize(N,vector(M,-1));

        //遍历mat将0入队并更新其dis
        queue<pair<int,int>> q;
        for(int i=0;i!=N;i++)
            for(int j=0;j!=M;j++)
                if(mat[i][j]==0){
                    q.push({i,j});
                    dis[i][j]=0;
                }
        //bfs
        while(!q.empty()){
            pair<int,int> cur=q.front();q.pop();
            int cur_x=cur.first;
            int cur_y=cur.second;
            for(int i=0;i!=4;i++){
                int next_x=cur_x+dx[i];
                int next_y=cur_y+dy[i];
                if(next_x>=0&&next_x<N&&next_y>=0&&next_y<M&&dis[next_x][next_y]==-1){
                    q.push({next_x,next_y});
                    dis[next_x][next_y]=dis[cur_x][cur_y]+1;
                }
            }
        } 
        return dis;
    }
};
相关推荐
C^h8 小时前
c++ string
开发语言·c++
raindayinrain8 小时前
c++高性能--原子操作,无锁编程,操作顺序
开发语言·c++·性能优化
学逆向的9 小时前
C++ 合并命名空间
开发语言·c++·网络安全
Zhao-Jichao9 小时前
VS2026 打包 C++ 程序生成 EXE,借助 Installer Project 扩展工具
开发语言·c++
小徐不徐说10 小时前
C++ 接口与插件设计:从工厂注册到 Qt 动态插件
数据库·c++·qt·系统架构·程序设计
大都督会赢的10 小时前
C++第一节课
开发语言·c++
UIU11410 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场10 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi10 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
TMedical11 小时前
MedPlanning 截骨模拟矫形功能
c++·图像处理·人工智能·qt·健康医疗